// TsUtilClass.h: TS[eBeB[NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// _Ci~bNt@XǗx[XNX
/////////////////////////////////////////////////////////////////////////////

class CDynamicReferenceable
{
public:
	CDynamicReferenceable();
	virtual ~CDynamicReferenceable();

	void AddRef(void);
	void ReleaseRef(void);

private:
	DWORD m_dwRefCount;
};


/////////////////////////////////////////////////////////////////////////////
// NeBJZNVbp[NX
/////////////////////////////////////////////////////////////////////////////

#ifndef _DEBUG
class CCriticalLock
{
public:
	CCriticalLock();
	virtual ~CCriticalLock();
	
	void Lock(void);
	void Unlock(void);
	
private:
	CRITICAL_SECTION m_CriticalSection;
};
#else
class CCriticalLock {
	CCritSec m_CritSec;
public:
	CCriticalLock() { DbgLockTrace(&m_CritSec,TRUE); }
	~CCriticalLock() {}
	void Lock() { /*m_CritSec.Lock();*/ }
	void Unlock() { /*m_CritSec.Unlock();*/ }
};
#endif


/////////////////////////////////////////////////////////////////////////////
// ubNXR[vbNNX
/////////////////////////////////////////////////////////////////////////////

class CBlockLock
{
public:
	CBlockLock(CCriticalLock *pCriticalLock);
	virtual ~CBlockLock();
		
private:
	CCriticalLock *m_pCriticalLock;
};


